"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ZodInputPatchRelationshipSchema = exports.ZodInputPostRelationshipSchema = exports.ZodInputPatchSchema = exports.ZodInputPostSchema = exports.ZodQuerySchema = exports.ZodInputQuerySchema = void 0;
const zod_1 = require("../helper/zod");
const constants_1 = require("../constants");
function ZodInputQuerySchema(entity) {
    return {
        provide: constants_1.ZOD_INPUT_QUERY_SCHEMA,
        inject: [
            {
                token: constants_1.CURRENT_DATA_SOURCE_TOKEN,
                optional: false,
            },
        ],
        useFactory: (dataSource) => (0, zod_1.zodInputQuerySchema)(dataSource.getRepository(entity)),
    };
}
exports.ZodInputQuerySchema = ZodInputQuerySchema;
function ZodQuerySchema(entity) {
    return {
        provide: constants_1.ZOD_QUERY_SCHEMA,
        inject: [
            {
                token: constants_1.CURRENT_DATA_SOURCE_TOKEN,
                optional: false,
            },
        ],
        useFactory: (dataSource) => (0, zod_1.zodQuerySchema)(dataSource.getRepository(entity)),
    };
}
exports.ZodQuerySchema = ZodQuerySchema;
function ZodInputPostSchema(entity) {
    return {
        provide: constants_1.ZOD_POST_SCHEMA,
        inject: [
            {
                token: constants_1.CURRENT_DATA_SOURCE_TOKEN,
                optional: false,
            },
        ],
        useFactory: (dataSource) => (0, zod_1.zodInputPostSchema)(dataSource.getRepository(entity)),
    };
}
exports.ZodInputPostSchema = ZodInputPostSchema;
function ZodInputPatchSchema(entity) {
    return {
        provide: constants_1.ZOD_PATCH_SCHEMA,
        inject: [
            {
                token: constants_1.CURRENT_DATA_SOURCE_TOKEN,
                optional: false,
            },
        ],
        useFactory: (dataSource) => (0, zod_1.zodInputPatchSchema)(dataSource.getRepository(entity)),
    };
}
exports.ZodInputPatchSchema = ZodInputPatchSchema;
exports.ZodInputPostRelationshipSchema = {
    provide: constants_1.ZOD_POST_RELATIONSHIP_SCHEMA,
    useValue: zod_1.zodInputPostRelationshipSchema,
};
exports.ZodInputPatchRelationshipSchema = {
    provide: constants_1.ZOD_PATCH_RELATIONSHIP_SCHEMA,
    useValue: zod_1.zodInputPatchRelationshipSchema,
};
//# sourceMappingURL=zod-validate.factory.js.map