"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pullAllData = exports.pullUserGroup = exports.pullUser = exports.pullRole = exports.pullNote = exports.pullComment = exports.pullAddress = void 0;
const faker_1 = require("@faker-js/faker");
const entities_1 = require("../entities");
async function pullAddress(addressRepo) {
    const address = new entities_1.Addresses();
    address.city = faker_1.faker.location.city();
    address.country = faker_1.faker.location.country();
    address.arrayField = [
        faker_1.faker.string.alphanumeric(5),
        faker_1.faker.string.alphanumeric(5),
    ];
    address.state = faker_1.faker.location.state();
    return addressRepo.save(address);
}
exports.pullAddress = pullAddress;
async function pullComment(commentRepo) {
    const comment = new entities_1.Comments();
    comment.text = faker_1.faker.lorem.paragraph(faker_1.faker.number.int(5));
    comment.kind = entities_1.CommentKind.Comment;
    return commentRepo.save(comment);
}
exports.pullComment = pullComment;
async function pullNote(noteRepo) {
    const note = new entities_1.Notes();
    note.text = faker_1.faker.lorem.paragraph(faker_1.faker.number.int(5));
    return noteRepo.save(note);
}
exports.pullNote = pullNote;
async function pullRole(roleRepo) {
    const role = new entities_1.Roles();
    role.key = faker_1.faker.string.alphanumeric(5);
    role.name = faker_1.faker.string.alphanumeric(5);
    return roleRepo.save(role);
}
exports.pullRole = pullRole;
async function pullUser(userPero) {
    const user = new entities_1.Users();
    user.firstName = faker_1.faker.person.firstName();
    user.lastName = faker_1.faker.person.lastName();
    user.isActive = faker_1.faker.datatype.boolean();
    user.login = faker_1.faker.internet.userName({
        lastName: user.lastName,
        firstName: user.firstName,
    });
    user.testDate = faker_1.faker.date.anytime();
    return userPero.save(user);
}
exports.pullUser = pullUser;
async function pullUserGroup(userGroupRepo) {
    const userGroup = new entities_1.UserGroups();
    userGroup.label = faker_1.faker.string.alphanumeric(5);
    return userGroupRepo.save(userGroup);
}
exports.pullUserGroup = pullUserGroup;
async function pullAllData(userPero, addressRepo, noteRepo, commentRepo, roleRepo, userGroupRepo) {
    const user = await pullUser(userPero);
    if (addressRepo) {
        user.addresses = await pullAddress(addressRepo);
    }
    if (noteRepo) {
        user.notes = [
            await pullNote(noteRepo),
            await pullNote(noteRepo),
            await pullNote(noteRepo),
        ];
    }
    if (commentRepo) {
        user.comments = [
            await pullComment(commentRepo),
            await pullComment(commentRepo),
            await pullComment(commentRepo),
            await pullComment(commentRepo),
        ];
    }
    if (userGroupRepo) {
        await pullUserGroup(userGroupRepo);
        await pullUserGroup(userGroupRepo);
        await pullUserGroup(userGroupRepo);
        user.userGroup = await pullUserGroup(userGroupRepo);
    }
    if (roleRepo) {
        await pullRole(roleRepo);
        await pullRole(roleRepo);
        await pullRole(roleRepo);
        user.roles = [
            await pullRole(roleRepo),
            await pullRole(roleRepo),
            await pullRole(roleRepo),
        ];
    }
    user.manager = await pullUser(userPero);
    await pullUser(userPero);
    await pullUser(userPero);
    await pullUser(userPero);
    await userPero.save(user);
    return user;
}
exports.pullAllData = pullAllData;
//# sourceMappingURL=pull-data.js.map